require 'active_model'
module Hermes
  module BoClient
    class Workflow

      PROCESS_DEFINITION='genericWSParaph'

      include BoClient::AttributesHelper
      include ActiveModel::Validations

      attr_accessor :client

      ATTRBUTE_NAMES=[:id,
                      :processInstanceId,
                      :COMPANY_CODE,
                      :paraphName,
                      :ordered_signers,
                      :code,
                      :email,
                      :phone,
                      :firstname,
                      :lastname,
                      :signautorizedbefore,
                      :signautorizedafter,
                      :sid_code]

      attr_accessor(*ATTRBUTE_NAMES)

      #alias_attribute :reference_offre, :offerId

      validates_presence_of :reference_offre, :reference

      def initialize(attrs={})
        process_attributes(attrs)
        set_defaults
      end

      #def set_defaults
      #  @sid_code||=self.company_code.downcase.gsub('fr-','')
      #end

      def client
        @client||=BoClient::Client.new
      end

      def initiate
        #r=client.post('/esignrest/restserver/workflow/execute', self.to_xml).xpath('//executeWorkflowResponse')
        #self.process_instance_id = r.xpath('processInstanceId').text
        #self.id = r.xpath('workflowNumber').text
        self
      end

      def to_xml
        builder=BoClient::WorkflowRequestBuilder.new do |b|
          b.attribute('processDefinition', PROCESS_DEFINITION)
          [:COMPANY_CODE,
          :paraphName,
          :ordered_signers,
          :code,
          :email,
          :phone,
          :firstname,
          :lastname,
          :signautorizedbefore,
          :signautorizedafter].each do |attr|
            v=self.send(attr)
            b.parameter(attr, v) if v
          end
        end
        builder.to_xml
      end

      def to_h
        ATTRBUTE_NAMES.each_with_object(Hash.new) do |key,h|
          h[key]=self.send(key)
        end
      end

    end
  end
end
