
require 'rails_helper'

RSpec.describe Hermes::EntityRequestAccount, type: :model do
  it 'has a valid factory' do
    expect(FactoryBot.build(:entity_request_account)).to be_valid
  end

  it "is not valid without an amount" do
    entity_request = Hermes::EntityRequestAccount.new(amount: nil, origin_entity_id: "1", entity_id: "3")
    expect(entity_request).to_not be_valid
  end

  it "is not valid without an origin id" do
    entity_request = Hermes::EntityRequestAccount.new(amount: 33, origin_entity_id: nil, entity_id: "3")
    expect(entity_request).to_not be_valid
  end

  it "is not valid without an entity id" do
    entity_request = Hermes::EntityRequestAccount.new(amount: 33, origin_entity_id: "1", entity_id: nil)
    expect(entity_request).to_not be_valid
  end

end 
